library(stockassessment)
load("run/model.RData")
FC<-list()
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,1,1), label="SQ all years", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.000001,0.000001, 0.000001), label="SQ then zero", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.23,0.23, 0.23), label="SQ then Fmsy", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.60,0.60, 0.60), label="SQ then Fp05", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.62,0.62, 0.62), label="SQ then Fpa", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.85,0.85, 0.85), label="SQ then Flim", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)

Ry<-1997:2022     # assessment year-1 
Fsq<-0.594        # latest value from SAM 
 # gives exactly Fsq value
set.seed(12345)
FC[[length(FC)+1]]  <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq, Fsq,Fsq,Fsq),rec.years=Ry, label="Rec 1997-2022, SQ all years", processNoise=FALSE,addTSB=TRUE, year.base=2023, savesim=TRUE) 
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.000001, 0.000001), rec.years=Ry, label="Rec 1997-2022, SQ then zero", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=TRUE)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.23, 0.23), rec.years=Ry, label="Rec 1997-2022, SQ then Fmsy", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=TRUE)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.60, 0.60), rec.years=Ry, label="Rec 1997-2022, SQ then Fpa/Fp05", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.62, 0.62), rec.years=Ry, label="Rec 1997-2022, SQ then Fpa", processNoise=FALSE, addTSB=TRUE, year.base=2023)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.85, 0.85), rec.years=Ry, label="Rec 1997-2022, SQ then Flim", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=TRUE)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.128, 0.128), rec.years=Ry, label="Rec 1997-2022, SQ then Fmsy*SSB2024/MSYBtrigger", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=TRUE)

Ry<-2018:2022     # latest 5 years as recommended from ADGdeep 2022 (wgdeep2023) 
Fsq<-0.594       # latest value from SAM 
 # gives exactly Fsq value
set.seed(12345)
FC[[length(FC)+1]]  <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq, Fsq,Fsq,Fsq),rec.years=Ry, label="Rec 2018-2022, SQ all years", processNoise=FALSE,addTSB=TRUE, year.base=2023, savesim=TRUE) 
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.000001, 0.000001), rec.years=Ry, label="Rec 2018-2022, SQ then zero", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=TRUE)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.23, 0.23), rec.years=Ry, label="Rec 2018-2022, SQ then Fmsy", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=TRUE)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.60, 0.60), rec.years=Ry, label="Rec 2018-2022, SQ then Fpa/Fp05", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.62, 0.62), rec.years=Ry, label="Rec 2018-2022, SQ then Fpa", processNoise=FALSE, addTSB=TRUE, year.base=2023)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.85, 0.85), rec.years=Ry, label="Rec 2018-2022, SQ then Flim", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=TRUE)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA), fval=c(Fsq,Fsq,0.127, 0.127), rec.years=Ry, label="Rec 2018-2022, SQ then Fmsy*SSB2024/MSYBtrigger", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=TRUE)
# Gives Fsq close but not exactly
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,1,1), rec.years=Ry, label="Rec 1996-2020, SQ all years", processNoise=FALSE, addTSB=TRUE, year.base=2021)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.000001, 0.000001), rec.years=Ry, label="Rec 1996-2020, SQ then zero", processNoise=FALSE, addTSB=TRUE, year.base=2021)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.23, 0.23), rec.years=Ry, label="Rec 1996-2020, SQ then Fmsy", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.60, 0.60), rec.years=Ry, label="Rec 1996-2020, SQ then Fp05", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.62, 0.62), rec.years=Ry, label="Rec 1996-2020, SQ then Fpa", processNoise=FALSE, addTSB=TRUE)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,NA,NA), fval=c(NA,NA,0.85, 0.85), rec.years=Ry, label="Rec 1996-2020, SQ then Flim", processNoise=FALSE, addTSB=TRUE)


Ry<-2018:2022     # latest 5 years as recommended from ADGdeep 2022 (wgdeep2023) 
Fsq<-0.594        # latest value from SAM 
 # gives exactly Fsq value
set.seed(12345)
FC[[length(FC)+1]]  <- forecast(fit, fscale=c(NA,NA,NA,NA,NA,NA), fval=c(Fsq, Fsq,Fsq,Fsq,Fsq,Fsq),rec.years=Ry, label="Rec 2018-2022, SQ all years*", processNoise=FALSE,addTSB=TRUE, year.base=2023, savesim=F) 
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA,NA,NA), fval=c(Fsq,Fsq,0.000001, 0.000001,0.000001, 0.000001), rec.years=Ry, label="Rec 2018-2021, SQ then zero*", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=F)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA,NA,NA), fval=c(Fsq,Fsq,0.23, 0.23,0.23, 0.23), rec.years=Ry, label="Rec 2018-2022, SQ then Fmsy*", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=F)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA,NA,NA), fval=c(Fsq,Fsq,0.60, 0.60,0.60, 0.60), rec.years=Ry, label="Rec 2018-2022, SQ then Fpa/Fp05*", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=F)
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA,NA,NA), fval=c(Fsq,Fsq,0.62, 0.62), rec.years=Ry, label="Rec 2018-2022, SQ then Fpa", processNoise=FALSE, addTSB=TRUE, year.base=2023)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA,NA,NA), fval=c(Fsq,Fsq,0.85, 0.85,0.85, 0.85), rec.years=Ry, label="Rec 2018-2022, SQ then Flim*", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=F)
set.seed(12345)
FC[[length(FC)+1]] <- forecast(fit, fscale=c(NA,NA,NA,NA,NA,NA), fval=c(Fsq,Fsq,0.127, 0.127,0.127, 0.127), rec.years=Ry, label="Rec 2018-2022, SQ then Fmsy*SSB2024/MSYBtrigger*", processNoise=FALSE, addTSB=TRUE, year.base=2023, savesim=F)

save(FC, file="run/forecast.RData")

